/* Copyright (C) Bill Buckels 2008 */


/* I have encoded the matrix below with zero's
   where the key is not a "plain" ascii value.

   The pointer base for kpress[0] at 203 provides
   the indices for this array for values (0-63)

   The value 0x40 (64) signals that the
   key has been released.

   The following serves little practical
   purpose unless you are looking ahead for
   an ascii value on a keydown especially with
   a full keyboard buffer.

   Most times the first key in the keyboard
   buffer itself is a better alternative since
   it offers all the key values on the C64
   translated to C64 ASCII mapping for everything
   including shifted values, All Function Keys etc.

   The following is indeterminate without that
   additional information.

   */

char kmatrix[64] = {
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,000,
  '3', 'W', 'A', '4', 'Z', 'S', 'E', '0',
  '5', 'R', 'D', '6', 'C', 'F', 'T', 'X',
  '7', 'Y', 'G', '8', 'B', 'H', 'U', 'V',
  '9', 'I', 'J', '0', 'M', 'K', 'O', 'N',
  '+', 'P', 'L', '-', '.', ':', '@', ',',
  0x00,'*', ';', 0x00,0x00,'=', 0x00,'/',
  '1', 0x00,0x00,'2', 0x00,0x00,'Q', 0x00};

