/*	Copyright (c) 1983 by Manx Software Systems, Inc.	*/

#include	"stdio.h"

static int (*_closret)();
extern int (*_closall)();

_flsh(c, b)
int c;
register FILE *b;
{
	static char clflg = 0;
	int fclosall();

	if (clflg == 0) {
		_closret = _closall;
		_closall = fclosall;
		clflg++;
	}

	if (b->_mode & _IOERROR)
		return(EOF);

	if ((b->_mode & _IOWRITE) == 0) {
		errno = E_BADMODE;
		return(EOF);
	}
	if (b->_base == 0)
		_initbuf(b);

	if (b->_bufsiz == 1) {
		if (c >= 0) {
			if (write(b->_fd, &c, 1) == -1) {
				b->_mode |= _IOERROR;
				return(EOF);
			}
			return(c&0xff);
		}
		return(0);
	}

	if (b->_mode & _IODTY) {							/* something to flush */
		b->_mode &= ~_IODTY;
		if (write(b->_fd, b->_base, b->_cp - b->_base) < 0) {
			b->_mode |= _IOERROR;
			return(EOF);
		}
	}
	b->_cp = b->_end = b->_base;
	if (c >= 0) {
		b->_end += b->_bufsiz;
		b->_mode |= _IODTY;
		*b->_cp++ = c;
		return(c&0xff);
	}
	return(0);
}

static
fclosall()
{
	register FILE *b;

	for (b= &_iob[0];b<&_iob[_NOBUFS];b++)
		fclose(b);
	(*_closret)();
}

fclose(b)
register FILE *b;
{
	register int i = 0;

	if (b->_mode & _IODTY) 
		i = _flsh(-1, b);
	i |= close (b->_fd);
	if (b->_bufsiz > 1)
		free(b->_base);
	b->_mode = 0;
	return(i);
}

