/*	Copyright (c) 1983 by Manx Software Systems, Inc.	*/

#include "stdio.h"

fseek (b, offset, mode)
register FILE *b;
long offset;
int mode;
{
	long lseek();

	if (b->_mode & _IOERROR)
		return(EOF);

	if (b->_mode & _IODTY) {
		if (_flsh(-1, b))
			return(EOF);
	}
	b->_mode &= ~_IOEOF;
	b->_end = b->_cp = b->_base;
	if (lseek(b->_fd, offset, mode) < 0){
		b->_mode |= _IOERROR;
		return(EOF);
	}
	return (0);
}

