/*	Copyright (C) 1983 by Manx Software Systems, Inc.	*/

#include	"io.h"
#include	"errno.h"

open(name, mode)
char *name;
int mode;
{
	int fd, dev;
	register struct fil_tab *fp;

	errno = 0;
	for (fp=_fil_tab;fp<_fil_tab+MAXFILES;fp++)
		if (fp->mode == 0xff)
			goto got_fp;
	errno = E_FILFULL;
	return(-1);
got_fp:
	fd = fp - _fil_tab;

	if (_get_dev(name, fp) < 0)
		return(-1);
	dev = fp->dev;
	if (fp->type == 0) {
		if (_call_dev(dev, DEV_OPEN, mode) < 0)
			return(-1);
		fp->mode = mode;
		return(fd);
	}

	if (fp->chan == 0xff)
		fp->chan = fd + 2;
	if(mode == 1)
		strcat(_name, ",W");
	_setlfs(fd+1, dev, fp->chan);
	_setnam(_name);
	if ((errno = _open()) == 0) {
		if (_status) {
			errno = 0x200 + _status;
			return(-1);
		}
		if (errno = _error(dev)) {
			_clrchn();
			_close(fd+1);
			errno |= 0x300;
			return(-1);
		}
		fp->byte = 2;
		fp->reclo = 1;
		fp->rechi = 0;
		fp->mode = mode;
		return(fd);
	}
	errno |= 0x100;
	return(-1);
}

