/*	Copyright (c) 1983 by Manx Software Systems, Inc.	*/

#define	_NOBUFS		8
#define _IOREAD		0x1
#define _IOWRITE	0x2
#define _IODTY		0x4
#define _IOINUSE	0x8
#define _IOBUFFED	0x10
#define _IOERROR	0x20
#define _IOEOF		0x40

int errno;
struct _iobuff {
	char *_cp;
	char *_end;
	char *_base;
	int _fd;
	int _mode;
	int _bufsiz;
	char _buff;
};

#define FILE	struct _iobuff

extern struct _iobuff _iob[];

#define stdin 	(&_iob[0])
#define stdout 	(&_iob[1])
#define stderr 	(&_iob[2])

#define _BUFSIZE	256

#define	putchar(c)	aputc(c, stdout)
#define	getchar()	agetc(stdin)
#define fileno(b)	(b->_fd)
#define fflush(b)  (_flsh(-1, (b)))
#define ferror(b)  (((b)->_mode & _IOERROR) != 0)
#define feof(b)  ((b)->_mode & _IOEOF)

#define EOF (-1)
#define NULL (0)

long ftell();

#define E_NOBUFS	-50			/* no stdio buffers available  */
#define E_BADMODE	-51			/* attempted to read/write with bad fopen mode*/
#define E_SKMODE	-52			/* invalid seek mode  */
#define E_BADSK		-53			/* seeked off the beg of file  */

