/* (C) Copyright Bill Buckels 2008 */

/* decode screen arrays saved with pcx run-length ecoding */
/* decode full screen images onto screen */
/* decode fragments into buffers */

decode_scr(ptr, bptr, target)
char *ptr, *bptr;
int target;
{
	int ctr=0, x, xcnt,ch;
    int offset=0;

	do{

		/* start with a seed count */
		xcnt=1;
	    ch=ptr[ctr];
	    ctr++;

	    /* check to see if its raw */
	    /* if its not, run encoded */
	    if(0xC0 == (ch & 0xc0)){
	       xcnt = 0x3f & ch;
	       ch = ptr[ctr];
	       ctr++;
	    }
	    for(x=0;x<xcnt;x++){
			if (offset < target) bptr[offset] = ch;
			else break;

			offset++;
		}

     } while(offset<target);

}