/* Copyright (C) Bill Buckels 2008 */

/* standard implementation of bresenham's */
drawline(x1,y1,x2,y2,color, mode)
int x1, y1, x2, y2, color, mode;
{
	register int dx,dy,ix,iy;
	int e,ei,ed,i;

	dx=x2-x1;
	dy=y2-y1;
	ix=1;
	if(dx<0)
		{ ix=-1;
		  dx=-dx;
		}
	iy=1;
	if(dy<0)
		{ iy=-1;
		  dy=-dy;
		}
	if(dy>dx)
		goto ylin;

	ei=2*dy;
	ed=ei-2*dx;
	e=-dx+ei;
    for(i=0;i<=dx;++i)
        {
        plot(x1,y1,color,mode);
		x1=x1+ix;
		if(e<0)
			e=e+ei;
		else{
			y1=y1+iy;e=e+ed;
		}
	}
	goto fin;

ylin:

	ei=2*dx;
	ed=ei-2*dy;
	e=-dy+ei;
	for(i=0;i<=dy;++i)
        {
          plot(x1,y1,color,mode);
		  y1=y1+iy;
		  if(e<0)
			e=e+ei;
		  else{ x1=x1+ix;e=e+ed;}
		}
fin:
;
}
