#include <stdio.h>
#include <poke.h>

/* globals to override the load point for the image loader  */
/* normally the loader centres partial images on the screen */
/* (C) Copyright Bill Buckels 2008 */

int XPIC=0;
int YPIC=0;

xpic(x)
int x;
{
	XPIC=x;
}

ypic(y)
int y;
{
	YPIC=y;
}

piclode(name, vname, cname, mode)
char *name, *vname, *cname;
int mode;
{
   int fh,y,y1=0,x1,bos;
   int temp;

   int rows,cols,packet;
   char tempchar[3];

   if (mode == 2 && NULL != cname) {
	   fh = open(cname,0);
	   if (fh != -1) {
          read(fh,tempchar,3);
          bordercolor[1] = tempchar[2] >> 4; /* set background */
          cram[0] = tempchar[2];
          read(fh,&cram[1],999);
          close(fh);

	   }
   }

   if ((mode == 2 || mode ==1) && NULL != vname) {
	   fh = open(vname,0);
	   if (fh != -1) {
          read(fh,tempchar,2);
          read(fh,&vram[0],1000);
          close(fh);

	   }
    }

   fh = open(name,0); /* open a binary file */
   if (fh == -1)return fh;

   read(fh,tempchar,2);
   if (tempchar[0] == 0 && tempchar[1] == 0x20) {
	   /* this is a fullscreen image */
       read(fh, &bmp[0], 8000);
       close(fh);
       return 0;
    }

   rows = (int)tempchar[0];
   cols = (int)tempchar[1];
   packet = cols * 8;


   /* center the picture in the screen */
   if(XPIC>39) {
      x1 = 20-(cols/2);
      if((x1%2)!=0)x1--;
   }
   else
      x1 = (int)XPIC;

   if((x1%2)!=0)x1--;

   if(YPIC>24) {
      y1=13-(cols/2);
      if((y1%2)!=0)y1--;
   }
   else
      y1=(int)YPIC;

   bos=y1+rows;

   for(y=y1;y<bos;y++) {
       temp = rbase(y) + cbase(x1);
       read(fh, &bmp[temp],packet); /* read 8 rasters to the screen */
   }
   close(fh);

   /* zero our globals each time */
   XPIC=0;
   YPIC=0;

   return 0;

}

