/*	Copyright (c) 1983 by Manx Software Systems, Inc.	*/
/*  Fixups Copyright (c) 2007 by Bill Buckels */
#define E_OVSMALL	-5
#define E_NOMEM		-6

int errno;

ovloader(ovname, args)
char *ovname;
{
	register int fd;
	register char *topmem;
	char *ovaddr;
	unsigned ovsize;
	register int (*ovbgn)();
	char buf[30];
	char *settop();

	strcpy(buf, ovname);
again:
	strcat(buf, ".OVR");
	if ((fd = open(buf, 0)) < 0)
			return -1;
	if (read(fd, &ovaddr, 2) <= 0)
		goto bad;
	if (read(fd, &ovsize, 2) <= 0)
		goto bad;
	topmem = settop(0);
	if (topmem < ovaddr + ovsize) {
		if (settop(ovaddr + ovsize - topmem) == 0) {
			errno = E_NOMEM;
			goto bad;
		}
	}
	if (read(fd, ovaddr, ovsize) < ovsize) {
		if (errno == 0)
			errno = E_OVSMALL;
bad:
		close(fd);
		return(-1);
	}
	close(fd);
	ovbgn = ovaddr;
	return((*ovbgn)());

}

