/*	Copyright (c) 1983 by Manx Software Systems, Inc.	*/

#include "stdio.h"

FILE *
fopen (path, type)
char *path, *type;
{
	register FILE *b, *_openf(), *_stream();

	b = &_iob[0];
	while (b->_mode) {
		if (++b >= &_iob[_NOBUFS]) {
			errno = E_NOBUFS; 		/* no buffers */
			return(NULL);
		}
	}
	return(_openf(b, path, type));
}

FILE *
_openf (b, path, type)
char *path;
register char *type;
register FILE *b;
{
	register int i;
	register char k;
	register unsigned mode;

	i = -1;
	k = type[1] == '+';

	switch(*type) {
	case 'r':
		mode |= _IOREAD;
		if (k) {
			mode |= _IOWRITE;
			i = open (path, 2);
		}
		else
			i = open(path, 0);
		break;
	case 'a':
	case 'w':
		mode |= _IOWRITE;
		i = creat(path, 0);
		if (k) {
			mode |= _IOREAD;
			close(i);
			i = open(path, 2);
		}
		if (*type == 'a' && lseek(i, 0L, 2) < 0) {
			close(i);
			i = -1;
		}
		break;
	}
	if (i < 0)
		return(NULL);
	b->_fd = i;
	b->_cp = b->_end = b->_base = 0;
	b->_bufsiz = _BUFSIZE;
	b->_mode = mode | _IOINUSE;
	return(b);
}

